{{- $fullName := include "piveau-metrics-cache.fullname" . -}}
apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    {{- include "piveau-metrics-cache.labels" . | nindent 4 }}
  name: {{ $fullName }}
spec:
  selector:
    matchLabels:
      {{- include "piveau-metrics-cache.selectorLabels" . | nindent 6 }}
  strategy:
    type: RollingUpdate
  template:
    metadata:
      labels:
        {{- include "piveau-metrics-cache.selectorLabels" . | nindent 8 }}
    spec:
      {{- if .Values.imagePullSecrets }}
      imagePullSecrets: {{ toYaml .Values.imagePullSecrets | nindent 8 }}
      {{- end }}
      containers:
        - name: {{ $fullName }}
          image: {{ printf "%s:%s" .Values.image .Values.imageTag }}
          imagePullPolicy: {{ .Values.imagePullPolicy }}
          ports:
            - containerPort: 8080
              name: default
          startupProbe:
            httpGet:
              path: /health
              port: default
            initialDelaySeconds: 20
            failureThreshold: 10
            periodSeconds: 10
          livenessProbe:
            httpGet:
              path: /health
              port: default
            failureThreshold: 1
            periodSeconds: 10
          {{- if .Values.resources }}
          resources: {{ toYaml .Values.resources | nindent 12 }}
          {{- end }}
          env:
            - name: SCHEDULES
              value: {{ toJson .Values.schedules | quote}}
            - name: JAVA_OPTS
              value: -XX:+ExitOnOutOfMemoryError {{ .Values.javaOpts }}

            {{- if .Values.mongodb.auth.databases }}
            - name: MONGODB_DB_NAME
              value: {{ default "metrics" (default .Values.database (index .Values.mongodb.auth.databases 0)) }}
            {{- end }}
            {{- if .Values.mongodb.auth.usernames }}
            - name: MONGODB_USERNAME
              value: {{ default "" (index .Values.mongodb.auth.usernames 0) }}
            {{- end }}
            {{- if .Values.mongodb.auth.passwords }}
            - name: MONGODB_PASSWORD
              value: {{ default "" (index .Values.mongodb.auth.passwords 0) }}
            {{- end }}
            {{- if .Values.extraEnvs }}
            {{- toYaml .Values.extraEnvs | nindent 12 }}
            {{- end }}
